#include "os.h"

unsigned long timer_ticks = 0;
unsigned long eticks;

void timer_handler(struct regs* r)
{
    ++timer_ticks;
    if (eticks)
        --eticks;

    //TEST
    char bufferTimerticks[20];            k_itoa (timer_ticks, bufferTimerticks);
	k_printf("             ",  6, 0x0B);  k_printf(bufferTimerticks, 6, 0x0B);
    char bufferWaitticks[20];         	  k_itoa (eticks, bufferWaitticks);
    k_printf("             ",  7, 0x0B);  k_printf(bufferWaitticks,  7, 0x0B);
    //TEST
}

void timer_wait (unsigned long ticks)
{
    timer_uninstall();
    eticks = ticks;
    timer_install();

    // busy wait...
    while (eticks)
    {
        k_printf("waiting time runs",   8, 0x0B);
        /* do nothing */;
    };
    k_printf("waiting time has passed", 9, 0x0B);
}

void sleepSeconds (unsigned long seconds)
{
    // based upon timer tick frequence of 18.222 Hz
    timer_wait((unsigned long)18.222*seconds);
}

void timer_install()
{
    /* Installs 'timer_handler' to IRQ0 */
    irq_install_handler(0, timer_handler);
}

void timer_uninstall()
{
    /* Uninstalls IRQ0 */
    irq_uninstall_handler(0);
}

